using System;
using System.Collections;
using MT.Tracker.DataStructures;

namespace MT.Tracker
{

	/// <summary>
	/// Summary description for FeaturePointDataManager.
	/// </summary>
//	public class TrackerMain
//	{
//		int _DoubleFrame = 0;		//Stores Number of dropped doubleframes
//		private FeaturePointData	_A;
//		private FeaturePointData	_R;
//		private FeaturePointData	_G;
//		private FeaturePointData	_B;
//
//		private Tracker				_TrackerR;
//		private Tracker				_TrackerG;
//		private Tracker				_TrackerB;
//
//		private int					_CameraID;
//
////		FrameLoader _Loader; 
////		FrameSaver _Saver;
//
//
//
//		public FeaturePointData Data
//		{
//			get { return _A; }
//		}
//
//
//		public FeaturePointData DataR
//		{
//			get { return _R; }
//		}
//
//		public FeaturePointData DataG
//		{
//			get { return _G; }
//		}
//
//		public FeaturePointData DataB
//		{
//			get {return _B; }
//		}
//
//		public int DoubleFrame
//		{
//			get { return _DoubleFrame; }
//		}
//
//		public TrackerMain(FeaturePointData A, FeaturePointData R, FeaturePointData G, FeaturePointData B,int CameraID)
//		{
//			//LoadPath = @"d:\Projekte\200310 Motion Tracking mit Webcams\sh_tracking\listen\skelett2_compress\";
//			//LoadName = "liste";
//
//			_CameraID = CameraID;
//			_A = A;
//			_R = R;
//			_G = G;
//			_B = B;
//			//Initalize 3 Trackers each for one color
//			_TrackerR = new Tracker(_R,"R", _CameraID);
//			_TrackerG = new Tracker(_G,"G", _CameraID);
//			_TrackerB = new Tracker(_B,"B", _CameraID);
//		
//			//_Loader = new FrameLoader(LoadPath,LoadName,"txt",5,this) ;
//			//_Saver = new FrameSaver(@"d:\Projekte\200310 Motion Tracking mit Webcams\sh_tracking\listen\Listen_logitech_white_10fps(35,20)\","liste_processed","txt",3) ;
//		
//		}
//
//		/// <summary>
//		/// Called by the parent, each time when a new Frame is available.
//		/// </summary>
//		public void TrackFrame()
//		{
//
//			int FrameCount = _A.CountFrames();
//
//			//The Tracker runs always one frame after the Frameloader
//			int curFrame = _A.CountFrames()-2;		
//
//			// ToDo: muss von der Controllerklasse verwaltet werden.
//			//_Loader.LoadFrame(++_LastRealFrame);
//
//			//First we calculate the least square error between the new frame and the previous frame
//			//The idea is to detect a phenomenon called double frame, which occurs when the computer
//			//hat a bufferoverflow during the recordingphase. Since the Trajectories are interrupted 
//			//by Doubleframes, we connect them manually
//			const float MIN_ERROR = 1f;
//
//			double error = 1000000.0;
//			//ToDo: Add Compare Method
//
//			if (FrameCount > 3)
//			{	//Calculate complete LS Error between current and previous frame
//				error = 0.0;
//				error += CalcLeastSquareError(_R.GetFrame(curFrame+1),_R.GetFrame(curFrame));
//				error += CalcLeastSquareError(_G.GetFrame(curFrame+1),_G.GetFrame(curFrame));
//				error += CalcLeastSquareError(_B.GetFrame(curFrame+1),_B.GetFrame(curFrame));
//
//			}
//
//
//			//Whenever we add a frame, check what can and has to be
//			//done by the trackers:
//			//For Framenumbers higher than 3 we process the Frame
//			//For Framenumbers equal 3 we initalize the tracker
//			if (FrameCount >3)
//			{
//				//Only if the error between 2 pictures is larger than our threshold
//				//we will analyse the new frame with the tracker else it is considered 
//				//a doubleframe and we manually connect identical Featurepoints.
//				if (error > MIN_ERROR)
//				{
//
//					_TrackerR.processFrame(curFrame);
//					_TrackerG.processFrame(curFrame);
//					_TrackerB.processFrame(curFrame);
//				}
//				else
//				{	//Manually connect Identical points
//					_TrackerR.processDoubleFrame(curFrame);
//					_TrackerG.processDoubleFrame(curFrame);
//					_TrackerB.processDoubleFrame(curFrame);
//					_DoubleFrame++;
//				}
//
//			}
//			else
//			{
//				if(FrameCount==3)
//				{
//					_TrackerR.initialize();
//					_TrackerG.initialize();
//					_TrackerB.initialize();
//				}
//			}
//
//			//Make sure, all FPs (even the unconnected ones) have a trajectoryID
//			//to allow correct classification by the TUK Tracker later.
//			_TrackerR.postProcessFrame(curFrame-1);
//			_TrackerG.postProcessFrame(curFrame-1);
//			_TrackerB.postProcessFrame(curFrame-1);
//
//		}
//
//		public void Finish()
//		{
//			_TrackerR.Finish();
//			_TrackerG.Finish();
//			_TrackerB.Finish();
//
//		}
//
//
//		//Calculates LeastSquare of 2 FeaturePointSets
//		private  double CalcLeastSquareError (SortedList a,  SortedList b)
//		{
//			SortedList S;
//			SortedList s;
//
//			int SCount;
//			int sCount;
//
//			double r = 0.0f;
//			int dP;					//Difference in FeaturePoints between a and b
//			float error=0.0f;
//			
//			if (a.Count > b.Count)
//			{
//				S= a;
//				s= b;
//			}
//			else
//			{
//				s= a;
//				S= b;
//			}
//
//			SCount = S.Count;
//			sCount = s.Count;
//
//			dP = SCount - sCount;
//
//			FeaturePoint P;
//			FeaturePoint p;
//
//			
//
//			for (int i = 0;i<sCount; i++)
//			{
//				p = (FeaturePoint)s.GetByIndex(i);
//
//				error = 1000000.0f;
//				for (int j=0; j<=dP; j++)
//				{
//					P = (FeaturePoint)S.GetByIndex(i+j);
//					error = System.Math.Min(error,(P.X -  p.X) * (P.X -  p.X)+ (P.Y -  p.Y) * (P.Y -  p.Y));
//				}
//			
//				r+= error;
//
//			}
//
//			return r;
//		
//		}
//	}
}
