using System;
using System.Collections;

namespace MT.Tracker.DataStructures
{
	/// <summary>
	/// SortedListExt is a SortedList with an Identifier value
	/// </summary>
	public class SortedListExt: SortedList
	{	private int _ID;

		/// <summary>
		/// Gets Original Framenumber
		/// </summary>
		public int ID
		{	get { return _ID; }	 }


		public SortedListExt(int ID)
		{
			_ID = ID;
		}
	}
}
