using System;
using MT.Tracker.DataStructures;

namespace MTServer
{
	/// <summary>
	/// Summary description for clsTesting.
	/// </summary>
	public class BPHypothesis
	{
		private static float _Vmax = 500;

		public BPHypothesis(vector3f BP1, vector3f BP2, vector3f BP3)
		{
			
		}



		public static float	gamma(vector3f BP1, vector3f BP2, vector3f BP3)
		{
			
			vector3f a = new vector3f(BP2.X - BP1.X, 
									  BP2.Y - BP1.Y,
									  BP2.Z - BP1.Z);

			vector3f b = new vector3f(BP3.X - BP2.X,
								      BP3.Y - BP2.Y,
				                      BP3.Z - BP2.Z);


			double dx = Math.Abs(a.X - b.X);
			double dy = Math.Abs(a.Y - b.Y);
			double dz = Math.Abs(a.Z - b.Z);

			return (float)((dx/_Vmax + dy/_Vmax + dz/_Vmax)/3.0f);

		}


	}
}
