using System;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr clsClientStatus.
	/// </summary>
	public class clsClientStatus
	{
		private string		_conID;		//Connection ID
		private string		_message;
		private MT.Network.clsBroadcastServer _Server;

		public clsClientStatus(string ConID, MT.Network.clsBroadcastServer Server)
		{
			_conID = ConID;
			_Server = Server;
			_Server.NewErrorMessage += new MT.Network.clsServer.NewErrorMessageDelegate(_Server_NewMessage);
			
			
		}

		private void _Server_NewMessage(string message, string message1)
		{
			//new ClientStatus Class will be created
			_message = message;

		}

		public string ConID
		{
			get{return _conID;}
		}

		public string message
		{
			get{return _message;}
		}
	}
}
