using System;
using System.Windows.Forms;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr clsMain.
	/// </summary>
	public class clsMain
	{
		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{	
			//Give Main Thread a name to make debugging easier
			System.Threading.Thread.CurrentThread.Name = "Main";

			//Create Main Controller Class and initialize everything
			clsServerController ServerCtrl = new clsServerController();
			ServerCtrl.Initialize();

			//Create Main Window and Connect it to the ServerCtrl
			frmServer MTServer = new frmServer();
			MTServer.Initialize(ServerCtrl);


			Application.Run(MTServer);
			
			
		}


	}
}
