using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr frm3DView.
	/// </summary>
	public class frm3DView : System.Windows.Forms.Form
	{
		private	cls3DView				_3DView;
		
//		int			_maxGLFrame= -1;		//Stores Maximal viewable Tracked frame
		int			_curGLFrame = -1;		//Stores Number of the currently showed frame in OpenGL Panel

		private System.Windows.Forms.TrackBar tbrFrame;
		private System.Windows.Forms.Panel pnlOpenGL;
		private System.Windows.Forms.Timer timerOpenGL;
		private System.Windows.Forms.Label lblInfo;
		private System.Windows.Forms.TextBox txtInfo;
		private System.ComponentModel.IContainer components;

		public frm3DView()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.tbrFrame = new System.Windows.Forms.TrackBar();
			this.pnlOpenGL = new System.Windows.Forms.Panel();
			this.timerOpenGL = new System.Windows.Forms.Timer(this.components);
			this.lblInfo = new System.Windows.Forms.Label();
			this.txtInfo = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).BeginInit();
			this.SuspendLayout();
			// 
			// tbrFrame
			// 
			this.tbrFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbrFrame.AutoSize = false;
			this.tbrFrame.Location = new System.Drawing.Point(0, 616);
			this.tbrFrame.Maximum = 0;
			this.tbrFrame.Name = "tbrFrame";
			this.tbrFrame.Size = new System.Drawing.Size(976, 20);
			this.tbrFrame.TabIndex = 35;
			this.tbrFrame.TickStyle = System.Windows.Forms.TickStyle.None;
			this.tbrFrame.LostFocus += new System.EventHandler(this.Ctrl_LostFocus);
			this.tbrFrame.GotFocus += new System.EventHandler(this.Ctrl_GotFocus);
			this.tbrFrame.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			this.tbrFrame.Scroll += new System.EventHandler(this.tbrFrame_Scroll);
			// 
			// pnlOpenGL
			// 
			this.pnlOpenGL.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlOpenGL.BackColor = System.Drawing.Color.Black;
			this.pnlOpenGL.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlOpenGL.Cursor = System.Windows.Forms.Cursors.Cross;
			this.pnlOpenGL.Location = new System.Drawing.Point(0, 0);
			this.pnlOpenGL.Name = "pnlOpenGL";
			this.pnlOpenGL.Size = new System.Drawing.Size(736, 616);
			this.pnlOpenGL.TabIndex = 34;
			this.pnlOpenGL.LostFocus += new System.EventHandler(this.Ctrl_LostFocus);
			this.pnlOpenGL.GotFocus += new System.EventHandler(this.Ctrl_GotFocus);
			this.pnlOpenGL.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseUp);
			this.pnlOpenGL.Paint += new System.Windows.Forms.PaintEventHandler(this.pnlOpenGL_Paint);
			this.pnlOpenGL.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseMove);
			this.pnlOpenGL.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			this.pnlOpenGL.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseDown);
			// 
			// timerOpenGL
			// 
			this.timerOpenGL.Tick += new System.EventHandler(this.timerOpenGL_Tick_1);
			// 
			// lblInfo
			// 
			this.lblInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblInfo.BackColor = System.Drawing.Color.WhiteSmoke;
			this.lblInfo.Location = new System.Drawing.Point(736, 0);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(240, 616);
			this.lblInfo.TabIndex = 36;
			// 
			// txtInfo
			// 
			this.txtInfo.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtInfo.Location = new System.Drawing.Point(800, 480);
			this.txtInfo.Multiline = true;
			this.txtInfo.Name = "txtInfo";
			this.txtInfo.Size = new System.Drawing.Size(184, 136);
			this.txtInfo.TabIndex = 37;
			this.txtInfo.Text = "Information";
			// 
			// frm3DView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(976, 637);
			this.Controls.Add(this.lblInfo);
			this.Controls.Add(this.pnlOpenGL);
			this.Controls.Add(this.tbrFrame);
			this.Controls.Add(this.txtInfo);
			this.Name = "frm3DView";
			this.Text = "frm3DView";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frm3DView_Closing);
			this.GotFocus += new System.EventHandler(this.Ctrl_GotFocus);
			this.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			this.LostFocus += new System.EventHandler(this.Ctrl_LostFocus);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		public void Initialize(TUKMain tukMain)
		{
			_3DView = new cls3DView(this.pnlOpenGL, tukMain);
			_3DView.Initialize();

			//timerOpenGL.Enabled = true;
		}

		private void tbrFrame_Scroll(object sender, System.EventArgs e)
		{
			_curGLFrame = tbrFrame.Value;
			refreshGL();
		}

		private void refreshGL()
		{
			_3DView.refreshGL();
		}

		private void pnlOpenGL_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			refreshGL();
		}

		private void pnlOpenGL_MouseMove(object sender, System.Windows.Forms.MouseEventArgs  e)
		{	
			_3DView.pnlOpenGL_MouseMove(e);
		}

		private void pnlOpenGL_MouseDown(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			pnlOpenGL.Focus();
			_3DView.pnlOpenGL_MouseDown(e);
		}

		private void pnlOpenGL_MouseUp(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			_3DView.pnlOpenGL_MouseUp(e);
		}

		public void pnlOpenGL_MouseWheel(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			_3DView.pnlOpenGL_MouseWheel(e);
		}

		private void Ctrl_GotFocus(object sender, EventArgs e)
		{
			Console.WriteLine("{0} got focus", sender.ToString());
		}

		private void Ctrl_LostFocus(object sender, EventArgs e)
		{
			Console.WriteLine("{0} lost focus", sender.ToString());
		}

		private void timerOpenGL_Tick_1(object sender, System.EventArgs e)
		{
			refreshGL();
		}

		delegate void setTextDelegate(string value);

		private void setText(string value)
		{
			this.lblInfo.SuspendLayout();
			this.lblInfo.Text = value;
			this.lblInfo.ResumeLayout();
		}



		public string TextInformation
		{
//			get{return this.txtInfo.Text;}
//			set
//			{
//				this.txtInfo.Text = value;
//			}
			get{return this.lblInfo.Text;}
			set
			{
				if(InvokeRequired)
				{
					BeginInvoke(new setTextDelegate(setText),new Object[]{value});
				}
				else
				{
					setText(value);
				}
			}
		}

		private void frm3DView_Closing(object sender, CancelEventArgs e)
		{
			_3DView.Disable();
		}
	}
}
